#include <iostream>
#include <stack>
#include "stackIOint.hh"
using namespace std; 


// Elemento dominador más alto de una pila de naturales. Un elemento
// de una pila de números es dominador si es mayor o igual que la suma
// de los elementos más antiguos (i.e. los que se situan más abajo que
// él). Dada una pila de naturales queremos obtener el elemento
// dominador más reciente o equivalentemente más alto


int suma(stack<int> p) 
/* Pre: p = P */
/* Post: el resultado es la suma de los elementos de P */
{
  int s = 0; 
  /* Inv: s es la suma de los elementos de la parte tratada de P,  
     p es la parte que queda por tratar de P */
  while (not p.empty()) {
     s += p.top();
     p.pop();
  }
  return s;
}


// dom calcula muchas sumas repetidas. En la primera llamada calcula
// la suma de todos los elementos de P menos la cima, en la segunda
// llamada recursiva la suma de todos los elementos menos la primera y
// segunda cimas, y así sucesivamente. El número total de sumas que
// hace es cuadrático en la altura de la pila.

int dom(stack<int>& p) 
/* Pre: p=P, p no está vacía y está formada por naturales */
/* Post: el resultado es el elemento dominador más alto de P */
{
  int r = p.top(); 
  p.pop(); 
  if (not p.empty()) {
    if (r < suma(p)) r = dom(p); 
    /* HI: r es el elemento dominador más alto de P sin la cima */
  }
  return r;
}


int main() {
  stack<int> p; 
  lee(p); 
  esc(p); 
  cout << "dom: " << dom(p) << endl;
}
