#include <iostream>
#include <stack>
#include "stackIOint.hh"
using namespace std; 


// Inmersión por datos: Si antes de comenzar el cálculo disponemos de
// la suma de los elementos de la pila, podemos obtener la siguiente
// función, que es lineal en la altura de la pila.


int suma(stack<int> p) 
/* Pre: p = P */
/* Post: el resultado es la suma de los elementos de P */
{
  int s = 0; 
  /* Inv: s es la suma de los elementos de la parte tratada de P 
     p es la parte que queda por tratar de P */
  while (not p.empty()) {
     s += p.top();
     p.pop();
  }
  return s;
}



int dom_dat(stack<int>& p, int s) {
/* Pre: p=P, p no es vacía y p está formada por naturales, 
   s es la suma de todos los elementos de P menos la cima */
/* Post: el resultado es el elemento dominador más alto de P */
  int r = p.top(); 
  if (r < s) {
     p.pop();
     if (not p.empty()) { 
        s -= p.top();
        r = dom_dat(p,s);
        /*  HI : r es el elemento dominador más alto de P sin la cima */
     }
  }
  return r;
} 


int dom(stack<int>& p) 
/* Pre: p=P, p no está vacía y está formada por naturales */
/* Post: el resultado es el elemento dominador más alto de P */
{
  return dom_dat(p,suma(p)-p.top());
}


int main() {
  stack<int> p; 
  lee(p); 
  esc(p); 
  cout << "dom: " << dom(p) << endl;
}
