#include <iostream>
#include <stack>
#include "stackIOint.hh"
using namespace std; 


// Inmersión por resultados: se devuelve el elemento dominador más
// alto y la suma de los elementos de la pila. Esto permite que cada
// llamada recursiva sólo tenga que sumar la cima de la pila a la
// suma devuelta por la siguiente llamada recursiva, en lugar de
// calcular la suma de toda la pila.

// dom_res genera tantas llamadas recursivas como la altura de la pila
// menos uno y en cada llamada realiza un número constante de operaciones
// básicas. Por tanto, es lineal.

pair<int,int> dom_res(stack<int>& p) {
/* Pre: p=P, p no está vacía y está formada por naturales */
/* Post: el resultado es un par formado por el elemento dominador más
   alto de P y la suma de los elementos de P */
  pair<int,int> r;
  if (p.size() == 1) {
     r.first = p.top(); 
     r.second = p.top(); 
  }
  else {
     int t = p.top();
     p.pop();
     r = dom_res(p);
     /* HI: r es un par formado por el elemento dominador más alto de
	P sin la cima y la suma de los elementos de P sin la cima */
     if (t >= r.second) r.first = t; 
     r.second += t;
  }
  return r;
} 


int dom(stack<int>& p) 
/* Pre: p=P, p no está vacía y está formada por naturales */
/* Post: el resultado es el elemento dominador más alto de P */
{
  return dom_res(p).first;
}


int main() {
  stack<int> p; 
  lee(p); 
  esc(p); 
  cout << "dom: " << dom(p) << endl;
}
