#include <iostream> 
using namespace std; 


// Inmersión por resultados: devuelve los dos últimos términos de la
// sucesión de Fibonacci

// ir_fib(n) hace n-1 llamadas recursivas, y en cada llamada se realiza
// un número constante de instrucciones básicas. Por tanto, es lineal.

pair<int,int> ir_fib(int n) 
/* Pre: n > 0 */
/* Post: el resultado es un par formado por los términos 
   n y n-1 de la sucesión de Fibonacci */
{
  pair<int,int> r; 
  if (n == 1) {
     r.first = 1; 
     r.second = 0; 
  }
  else {
     r = ir_fib(n-1);
     /* HI: r es un par formado por los términos n-1 y 
        n-2 de la sucesión de Fibonacci */
     int aux = r.first;
     r.first = r.first + r.second;
     r.second = aux; 
  }
  return r; 
}


int fib(int n) 
/* Pre: n >= 0 */
/* Post: el resultado es el término n-ésimo de la sucesión de Fibonacci */
{
  int r; 
  if (n == 0) r = 0; 
  else r = ir_fib(n).first;
  return r;
}


int main() {
  int x; 
  cin >> x; 
  cout << fib(x) << endl; 
}
